fmla_num_tmp <- fmla_ltfu_num_tmp <- fmla_main_tmp <- vector('list',length=length(iv))


cnt <- 1
for(i in 1:length(iv)){
#      fmla_num_tmp[[cnt]] <- as.formula(paste0(iv[i],' ~ ',paste('rcs(month,4)',ivLagged[i],sep=' + ')))
      fmla_num_tmp[[cnt]] <- as.formula(paste0(iv[i],' ~ ',paste('month',ivLagged[i],sep=' + ')))

      fmla_ltfu_num_tmp[[cnt]] <- as.formula(paste0('ltfu_time_varying_cvd',' ~ ',paste('rcs(month,4)',ivLagged[i],sep='+')))
      names(fmla_num_tmp)[[cnt]] <- ivShort[i]
      names(fmla_ltfu_num_tmp)[cnt] <- 'ltfu'

#      fmla_main_tmp[[cnt]] <- as.formula(paste0('cvd_or_thrombosis_event_time_varying ~ ',paste('rcs(month,4)',iv[i],sep=' + ')))
      fmla_main_tmp[[cnt]] <- as.formula(paste0('cvd_or_thrombosis_event_time_varying ~ ',paste('month',iv[i],sep=' + ')))

      cnt <- cnt + 1
}

mod_num_tmp <- vector('list',length=length(iv))
for(i in 1:3){

   mod_num_tmp[[i]] <- glm(fmla_num_tmp[[i]],
                           data = dataList[['cvd_or_thrombosis']],
                           family='binomial',
                           na.action=na.exclude)

}
names(mod_num_tmp) <- ivShort

mod_ltfu_num_tmp <- vector('list',length=length(iv))

for(i in 1:3){
   mod_ltfu_num_tmp[[i]] <- glm(fmla_ltfu_num_tmp[[i]],
                                data=dataList[['cvd_or_thrombosis']],
                                family='binomial',
                                na.action=na.exclude)

}


num_tmp_pp <- lapply(1:length(mod_num_tmp), FUN=function(i){
                 exp(predict(mod_num_tmp[[i]]))/(1+exp(predict(mod_num_tmp[[i]])))
              })
names(num_tmp_pp) <- ivShort


num_ltfu_pp_tmp <- lapply(1:length(mod_ltfu_num_tmp), FUN=function(i){
                      exp(predict(mod_ltfu_num_tmp[[i]]))/(1+exp(predict(mod_ltfu_num_tmp[[i]])))
                   })


# Calculating weights (initial step):
dataList[[1]]$wt_any_tmp <- ifelse(dataList[[1]]$hc_use_any_indicator == 1,
                                   num_tmp_pp[[i]]/denom_pp[[1]][['any']],
                                   ifelse(dataList[[1]]$hc_use_any_indicator == 0,
                                          (1-num_tmp_pp[[i]])/(1-denom_pp[[1]][['any']]),
                                           NA))
dataList[[1]]$wt_oral_tmp <- ifelse(dataList[[1]]$hc_use_oral_indicator == 1,
                                    num_tmp_pp[[i]]/denom_pp[[1]][['oral']],
                                    ifelse(dataList[[1]]$hc_use_oral_indicator == 0,
                                           (1-num_tmp_pp[[i]])/(1-denom_pp[[1]][['oral']]),
                                            NA))
dataList[[1]]$wt_depo_tmp <- ifelse(dataList[[1]]$hc_use_depo_indicator == 1,
                                    num_tmp_pp[[i]]/denom_pp[[1]][['depo']],
                                    ifelse(dataList[[1]]$hc_use_depo_indicator == 0,
                                           (1-num_tmp_pp[[i]])/(1-denom_pp[[1]][['depo']]),
                                            NA))

dataList[[1]]$wt_ltfu_any_tmp <- (1-num_ltfu_pp_tmp[[1]])/(1-denom_ltfu_pp[[1]][['any']])
dataList[[1]]$wt_ltfu_oral_tmp <- (1-num_ltfu_pp_tmp[[2]])/(1-denom_ltfu_pp[[1]][['oral']])
dataList[[1]]$wt_ltfu_depo_tmp <- (1-num_ltfu_pp_tmp[[3]])/(1-denom_ltfu_pp[[1]][['depo']])


# Cumulative weights:
dataList[[1]]$cum_wt_any_tmp <- NA
split(dataList[[1]]$cum_wt_any_tmp, dataList[[1]]$cfar_pid) <- lapply(split(dataList[[1]]$wt_any_tmp, dataList[[1]]$cfar_pid), FUN=function(y){
                                                                      cumprod(y) })


dataList[[1]]$cum_wt_any_ltfu_tmp <- NA
split(dataList[[1]]$cum_wt_any_ltfu_tmp, dataList[[1]]$cfar_pid) <- lapply(split(dataList[[1]]$wt_ltfu_any_tmp, dataList[[1]]$cfar_pid), FUN=function(y){
                                                                                  cumprod(y) })
dataList[[1]]$cum_wt_any_tmp <- dataList[[1]]$cum_wt_any_tmp * dataList[[1]]$cum_wt_any_ltfu_tmp

quant_any_tmp <- quantile(dataList[[1]]$cum_wt_any_tmp, probs=c(trim_amt[1],trim_amt[2]))
dataList[[1]]$cum_wt_any_tmp <- ifelse(dataList[[1]]$cum_wt_any_tmp < quant_any_tmp[1], quant_any_tmp[1],
                                       ifelse(dataList[[1]]$cum_wt_any_tmp > quant_any_tmp[2],
                                              quant_any_tmp[2],
                                              dataList[[1]]$cum_wt_any_tmp))

dataList[[1]]$cum_wt_oral_tmp <- NA
split(dataList[[1]]$cum_wt_oral_tmp, dataList[[1]]$cfar_pid) <- lapply(split(dataList[[1]]$wt_oral_tmp, dataList[[1]]$cfar_pid), FUN=function(y){
                                                                      cumprod(y) })

dataList[[1]]$cum_wt_oral_ltfu_tmp <- NA
split(dataList[[1]]$cum_wt_oral_ltfu_tmp, dataList[[1]]$cfar_pid) <- lapply(split(dataList[[1]]$wt_ltfu_oral_tmp, dataList[[1]]$cfar_pid), FUN=function(y){
                                                                                  cumprod(y) })
dataList[[1]]$cum_wt_oral_tmp <- dataList[[1]]$cum_wt_oral_tmp * dataList[[1]]$cum_wt_oral_ltfu_tmp

quant_oral_tmp <- quantile(dataList[[1]]$cum_wt_oral_tmp, probs=c(trim_amt[1],trim_amt[2]))
dataList[[1]]$cum_wt_oral_tmp <- ifelse(dataList[[1]]$cum_wt_oral_tmp < quant_oral_tmp[1], quant_oral_tmp[1],
                                       ifelse(dataList[[1]]$cum_wt_oral_tmp > quant_oral_tmp[2],
                                              quant_oral_tmp[2],
                                              dataList[[1]]$cum_wt_oral_tmp))

dataList[[1]]$cum_wt_depo_tmp <- NA
split(dataList[[1]]$cum_wt_depo_tmp, dataList[[1]]$cfar_pid) <- lapply(split(dataList[[1]]$wt_depo_tmp, dataList[[1]]$cfar_pid), FUN=function(y){
                                                                      cumprod(y) })

dataList[[1]]$cum_wt_depo_ltfu_tmp <- NA
split(dataList[[1]]$cum_wt_depo_ltfu_tmp, dataList[[1]]$cfar_pid) <- lapply(split(dataList[[1]]$wt_ltfu_depo_tmp, dataList[[1]]$cfar_pid), FUN=function(y){
                                                                                  cumprod(y) })
dataList[[1]]$cum_wt_depo_tmp <- dataList[[1]]$cum_wt_depo_tmp * dataList[[1]]$cum_wt_depo_ltfu_tmp

quant_depo_tmp <- quantile(dataList[[1]]$cum_wt_depo_tmp, probs=c(trim_amt[1],trim_amt[2]))
dataList[[1]]$cum_wt_depo_tmp <- ifelse(dataList[[1]]$cum_wt_depo_tmp < quant_depo_tmp[1], quant_depo_tmp[1],
                                       ifelse(dataList[[1]]$cum_wt_depo_tmp > quant_depo_tmp[2],
                                              quant_depo_tmp[2],
                                              dataList[[1]]$cum_wt_depo_tmp))






names(fmla_main_tmp) <- ivShort
   main_cvd_mod[[i]] <- lrm(fmla_main_cvd[[i]],
                            data = dataList[[1]],
                            weights = dataList[[1]][[cumWtNames[i]]],
                            x = TRUE,
                            y = TRUE)

   modCVDGlm <- glm(fmla_main_cvd[[i]],
                    data = dataList[[1]],
                    weights = dataList[[1]][[cumWtNames[i]]],
                    family = 'binomial')

   modCVDGlmS <- sandwich(modCVDGlm)
   main_cvd_mod[[i]]$var <- modCVDGlmS

   main_mod_any_tmp <- lrm(fmla_main_tmp[['any']],
                           data = dataList[[1]],
                           weights = dataList[[1]]$cum_wt_any_tmp,
                           x = TRUE,
                           y = TRUE)
   modGlm <- glm(fmla_main_tmp[['any']],
                 data=dataList[[1]],
                 weights=dataList[[1]]$cum_wt_any_tmp,
                 family='binomial')
   modGlmS <- sandwich(modGlm)
   main_mod_any_tmp$var <- modGlmS

   main_mod_oral_tmp <- lrm(fmla_main_tmp[['oral']],
                            data = dataList[[1]],
                            weights = dataList[[1]]$cum_wt_oral_tmp,
                            x = TRUE,
                            y = TRUE)
   modGlm <- glm(fmla_main_tmp[['oral']],
                 data=dataList[[1]],
                 weights=dataList[[1]]$cum_wt_oral_tmp,
                 family='binomial')
   modGlmS <- sandwich(modGlm)
   main_mod_oral_tmp$var <- modGlmS

   main_mod_depo_tmp <- lrm(fmla_main_tmp[['depo']],
                            data = dataList[[1]],
                            weights = dataList[[1]]$cum_wt_depo_tmp,
                            x = TRUE,
                            y = TRUE)
   modGlm <- glm(fmla_main_tmp[['depo']],
                 data=dataList[[1]],
                 weights=dataList[[1]]$cum_wt_depo_tmp,
                 family='binomial')
   modGlmS <- sandwich(modGlm)
   main_mod_depo_tmp$var <- modGlmS

#Warning message:
#In eval(family$initialize) : non-integer #successes in a binomial glm! -- Figure out!!


